#!/usr/bin/python
############################################################################# 
#   Another collection of simple things to know                    Ver 0.1  #
#                                                                           # 
#  Author: Dylan A. Shell                                                   #
#                                                                           #
############################################################################# 

import time 
import sys  
import numpy 


def compute_sum_of_list(l):
    sum_of_list = 0
    for i in l:
        sum_of_list = sum_of_list + i
    return sum_of_list


def compute_another_sum_of_list(l):
    if len(l) == 1:
        return l[0]
    return l[0] + compute_sum_of_list(l[1:])


def do_some_list_examples():
    l = range(50,0,-5) # Numbers 50, 45, 40, .... 10, 5
    print "Here is our list:"
    print l
    print "Here is the first element:"
    print l[0]
    print "Here is the last element:"
    print l[-1]
    print "Here is a slice of the list from [2,5):"
    print l[2:5]


    print "The sum of the list is:"
    print compute_sum_of_list(l)
    print ""

    print "Another sum of the list is:"
    print compute_another_sum_of_list(l)

    s = [1]
    for i in range(10):
        print "s = " ,
        print s
        s = s + [compute_sum_of_list(s)]

    s = [0]
    for i in range(4):
        print "s = " ,
        print s
        s = [s, s]


def nop(x):
    return x

def square(x):
    return x*x

def negate(x):
    return -(x)

def sumtwo(x,y):
    return x+y

def multiplytwo(x,y):
    return x*y

def general_applier(li, f_on_each_element, f_to_collect):
    if len(li) == 1:
        return f_on_each_element(li[0])
    return f_to_collect(f_on_each_element(li[0]), general_applier(li[1:], f_on_each_element, f_to_collect))
    
def nopcollect(x,y):
    if not isinstance(y,list):
        return [x,y]
    return [x] + y

def do_some_functional_examples():
    l = range(4,0,-1) 
    print "Here is our list:"
    print l

    print "Here is our list with map applied:"
    ls = map(square, l)
    print ls

    print "Apply square, and sum up:"
    print general_applier(l, square, sumtwo)
    print "Do nothing, and sum up:"
    print general_applier(l, nop, sumtwo)
    print "Do nothing, and get product:"
    print general_applier(l, nop, multiplytwo)
    print "Square and get final product:"
    print general_applier(l, square, multiplytwo)
    print "Do nothin and get final product, then square:"
    print square(general_applier(l, nop, multiplytwo))
    print "Square and don't collect:"
    print general_applier(l, square, nopcollect)


def do_some_matrix_examples():
    # Here is a matrix
    a = numpy.array([[1., 2., 3.], [3., 4., 2.], [0., 0., 9.]])
    print "Here is a matrix:"
    print (a) 

    print "Computing its inverse."
    ainv = numpy.linalg.inv(a)
    print "Here it is:"
    print (ainv) 

    print "Let's check."
    prod = numpy.dot(a, ainv)
    print "Here it is:"
    print (prod) 



def main(): 

    #print "These are the arguments that I got: %s" % sys.argv

    #do_some_list_examples()

    do_some_functional_examples()

    #do_some_matrix_examples()


if __name__ == "__main__":
    main()
