#!/usr/bin/python
############################################################################# 
#   Simple Game Example                                            Ver 0.1  #
#                                                                           # 
#   This program is another piece in code to demonstrate some features of   #
#   python                                                                  #
#                                                                           #
#  Author: Dylan A. Shell                                                   #
#                                                                           #
############################################################################# 

import time  # We use this library to allow us to put in delays
import sys   # We use sys to let us flush the output
import random 
import string
from ex6_dict import customdict

def display_main_screen():
    print "         WELCOME TO HANGMAN! v 0.1   "
    print "\n\n"

def display_victory():
    print ""
    print  "                         V I C T O R Y   "

def display_gameover(word):
    print  ""
    print  "                      G A M E   O V E R !"
    print  "\nThe word was \"%s\"\n" % word


display = [\
    [(1,'='),(1,'='),(1,'='),(1,'='),(1,'='),(1,'='),(1,'='),(1,'='),(1,'='),(1,'='),(1,'=')],
    [(1,'|'),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,':')],
    [(1,'|'),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(7,'_'),(2,'O'),(8,'_')],
    [(1,'|'),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(3,'|')],
    [(1,'|'),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(4,'|')],
    [(1,'|'),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(1,' '),(5,'/'),(1,' '),(6,'\\')],
    [(1,'#'),(1,'#'),(1,'#'),(1,'#'),(1,'#'),(1,'#'),(1,'#')],
    [(1,'#'),(1,'#'),(1,'#'),(1,'#'),(1,'#'),(1,'#'),(1,'#'),(1,'#'),(1,'#'),(1,'#'),(1,'#'),(1,'#'),(1,'#')]]

def display_status(display, g, word, guessed):
    c = 0
    for l in display:
        s = ""
        for i in l:
            if i[0]-1 <= g:
                s += i[1]
            else:
                s += " "
        print ("       %s" % s),
        c += 1
        if c == 4:
            print "     ",
            for i in range(len(word)):
                if guessed[i]:
                    print (" %c " % word[i]),
                else:
                    print (" _ "),

        print ""
    print ""
            

def get_max_display(display):
    m = 0
    for l in display:
        for i in l:
            m = max(m, i[0]-1)
    return m 


def main(): # Main entry into the program
    
    wrong_guesses=0
    game_over = False

    ind = random.randint(0,len(customdict))
    word = customdict[ind]

    guessed = [False] * len(word)
    total_guessed = 0

    display_steps = get_max_display(display)

    display_main_screen()

    while not game_over:

        display_status(display, wrong_guesses, word, guessed)

        inp_valid = False
        char = ''
        while not inp_valid:
            inp = raw_input('> ')
            if len(inp)==1:
               char = inp.lower() # Convert to case
               if string.lowercase.find(char) >= 0: # Check that it is in a-z
                    inp_valid = True 

            if not inp_valid:
                print "Invalid input, try again"
 
        total_guessed_before = total_guessed 
        for i in range(len(word)):
            if (not guessed[i]) and (word[i] == char):  
                guessed[i] = True
                total_guessed += 1
                break

        if total_guessed_before == total_guessed:
            wrong_guesses += 1
            if wrong_guesses == display_steps: 
                game_over = True

        if total_guessed == len(word):
            display_status(display, wrong_guesses, word, guessed)
            display_victory()
            return
            
    display_status(display, wrong_guesses, word, guessed)
    display_gameover(word)

            
if __name__ == "__main__":
    main()
